#include "pqueue.h"
#include <stdio.h>
#include <stdlib.h>

/*
Indstter et elementet som 'elem' peger p, med prioriteten 'pri'.
Det er muligt at indstte flere elementer med samme prioritet.
'pq' peger p en instans af prioritetsken.

Lykkedes indsttelsen skal funktionen returnerer '0'. Ved fejl '-1'.
*/
int pqueue_insert(pqueue_t *pq, unsigned int pri, void *elem)
{
  
  if(elem == NULL || pri <= 0) /* vi tillader ikke at indstte tomme elementer, eller elementer med pri < 1 */
    exit(-1); 


  if(pq->data == NULL) /* det er en tom liste og elem bliver det frste element */
    {  
      pq->data = elem;
      pq->pri = pri;
      pq->prev = pq; /* pga remove skal pq pege p sig selv hvis det er det eneste element i ken */ 
      printf("Frste element indsat. (pqueue.c) \n");
    }

  else /* ken er ikke tom, og vi skal indstte elem det rigtige sted...  */
    {
      int temp_pri;
      temp_pri = pq->pri;
      pqueue_t *temp_q;
      temp_q = pq;

      while (temp_pri < pri && temp_q->next != NULL)
	{
	  temp_q = temp_q->next;
	  temp_pri = temp_q->pri;
	}

      /* vi opretter en ny plads i ken og stter data=elem og pri=pri */
      pqueue_t *new = malloc(sizeof(pqueue_t));
      if (new == NULL)
	{exit(-1);}
      else
	{
	  new->data = elem;
	  printf("Der blev indsat %d\n", *((int*) elem));
	  new->pri = pri;
	}

      /* hvis elem skal indsttes sidst i ken (elem har hjest prioritet) */
      if(temp_q->next == NULL)
	{
	  temp_q->next = new;
	  new->next = NULL;
	  new->prev = temp_q;
	  /*
	    da elementet med hjeste pri altid vil vre det sidste
	    element i ken, stter vi frste elements prev til at
	    pege p det sidste element, s vi ikke skal kigge hele
	    ken igennem nr vi skal fjerne et element fra ken
	  */
	  pq->prev = new;
	}

      /* Hvis elem skal sttes ind imellem andre elementer i ken */
      else
	{
	  new->prev = temp_q->prev;	
	  new->next = temp_q;
	  if(temp_q == head) /* hvis det er et nyt frste element (nyt head -> lavest pri) */
	    {
	      temp_q->prev = new;
	      head = new;
	    }
	  else
	    {
	      (temp_q->prev)->next = new; 
	      temp_q->prev = new;
	    } 
	}
      
    }
  return 0;
 
}


/*
Returnerer det element som har hjst prioritet. Hvis flere elementer
har samme hjeste prioritet returneres det af dem, som frst blev indsat.

Hvis ken er tom, returneres 'NULL'.
*/
void *pqueue_remove(pqueue_t *pq)
{
  if(pq->data == NULL)
    {
      return NULL;
    }

  else
    { 
      
      if(pq->prev == pq) /* dette er det eneste element i ken */
	{
	  void *temp;
	  temp =  pq->data;
	  pq->pri = 0;
	  pq->data = NULL;
	  pq->next = NULL;
	  pq->prev = NULL;
	  return temp;
	}

      else
	{
	  pqueue_t *temp_q;
	  temp_q = pq->prev;
	  /* frste elements pointer til sidste element flyttes til nstsidste element */
	  pq->prev = (pq->prev)->prev;
	  /* det nstsidste element er nu det sidste element*/
	  ((pq->prev)->prev)->next = NULL;
	  
	  return temp_q->data;
	}
    }
}

pqueue_t *init_queue()
{

  head = malloc(sizeof(pqueue_t));
  if (head == NULL)
    exit(-1);
  head->pri  = 0;
  head->data = NULL;
  head->next = NULL;
  head->prev = NULL;
  
  return head;
  
  
}

